// Specific definitions for VxWorks  -*- C++ -*-

// Copyright (C) 2000-2018 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.

// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
// <http://www.gnu.org/licenses/>.

/** @file bits/os_defines.h
 *  This is an internal header file, included by other library headers.
 *  Do not attempt to use it directly. @headername{iosfwd}
 */

#ifndef _GLIBCXX_OS_DEFINES
#define _GLIBCXX_OS_DEFINES 1

// System-specific #define, typedefs, corrections, etc, go here.  This
// file will come before all others.

// Keep vxWorks from defining min()/max() as macros
#ifdef NOMINMAX
#undef NOMINMAX
#endif
#define NOMINMAX 1

#ifdef __RTP__

// Use VxWorks headers as a basis
#undef _GLIBCXX_INCLUDE_NEXT_C_HEADERS
#define _GLIBCXX_INCLUDE_NEXT_C_HEADERS 1

// WRS headers contain (once fixed) c++11 prototypes for FP
#define __CORRECT_ISO_CPP11_MATH_H_PROTO_FP

// C9X headers use dynamic FP macros
#undef _GLIBCXX_USE_C99_FP_MACROS_DYNAMIC
#define _GLIBCXX_USE_C99_FP_MACROS_DYNAMIC 1

#endif

// Do not emit weak references on VxWorks.
// * in kernel mode, this won't work at all
// * in RTP mode, weak refs are unsupported on VxWorks6, and
//   on vx7 it depends on the actual release.
#define _GLIBCXX_USE_WEAK_REF 0

// Do not include the inline definitions from VxWorks headers, and use the
// ones from libstdc++ instead
#define _NO_CPP_INLINES

#endif
